#ifndef _TICKYPIP_LEVEL_H_
#define _TICKYPIP_LEVEL_H_
#include <stddef.h>

//#include <qfile.h>
#include <f32file.h>
class Board;

class Level:public CBase
{
	public:
		Level(Board *board = NULL);
		Level(TDesC& name, Board *board = NULL);
		virtual ~Level();

		void setBoard(Board *board);
		Board *getBoard() const;

		const TDes& getTitle() const;
		size_t getNumLevels() const;

		bool loadLevelFile(const TDesC& filename);

		virtual bool setupLevel(size_t level) = 0;
		TInt Record(size_t level);
		void SetRecord(size_t level, TUint16 moves);
	protected:
		void setTitle(const TDesC &title);
		void setNumLevels(size_t num);

		virtual bool readHeader() { return true; }
		virtual bool isValidFormat() = 0;

	protected:
		RFile f;
		TInt iFileSize;
	private:
		Board *board;
		TBuf<64> title;
		size_t numLevels;
		TFileName iFileName;
		TUint16* iRecords;
};

#include "base.h"

#endif /* _TICKYPIP_LEVEL_H_ */
