#ifndef _TICKYPIP_QTPBOARD_H_
#define _TICKYPIP_QTPBOARD_H_

#include "base.h"
//#include <qframe.h>
//#include <qpainter.h>
#include <coecntrl.h>
class Tickypip;

class QTPBoard : public CCoeControl, UpdateListener
{
//	Q_OBJECT
	
	public:
		QTPBoard( Tickypip *tickypip = NULL);
		~QTPBoard();

		void loadLevel( TDes &filename, size_t num);

		void setBoard(Board *board);
		Board *getBoard() const;

		void clear();

		void cellUpdated(int x, int y, Cell *cell);

		void PositionChanged();
		void resetSizes();
		TBool iDisableUpdate;		
	protected:

		void drawCell(QPainter &paint, Cell *cell)const;
		void drawCells(QPainter &paint)const;
		void drawBoard(QPainter &paint)const;

		virtual void Draw(const TRect& aRect) const;
		virtual void HandlePointerEventL(const TPointerEvent& aPointerEvent);

	private:
		int pos2index(int x) { return x / SCALE; }
		int index2pos(int i) { return i * SCALE; }

	private:
		enum
		{
			MIN_WIDTH  =  5,
			MIN_HEIGHT =  5,
			MAX_WIDTH  = 10,
			MAX_HEIGHT = 10,
			SCALE      = 20
		};

		Tickypip *tickypip;
		Board *board;
};

#endif /* _TICKYPIP_QTPBOARD_H_ */
