#ifndef QTH
#define QTH
#include <e32std.h>
#include <e32base.h>
#include <gdi.h>
#include <w32std.h>
#include <stddef.h>

class QColor
{
public:
	QColor(int r,int g,int b)
	{
		iColor = TRgb(r,g,b);
	}

	QColor(TRgb aRgb)
	{
		iColor = aRgb;
	}
	const TRgb& Color()const{return iColor;}
private:
	TRgb iColor;
};

class QPainter
{
public:
	QPainter(CWindowGc* aGc){iGc = aGc;iPenColor = KRgbBlack;};
	void drawLine(int aX1,int aY1,int aX2,int aY2)
	{
		iGc->SetBrushStyle(CGraphicsContext::ESolidBrush);
		iGc->SetBrushColor(KRgbWhite);
		iGc->SetPenStyle(CGraphicsContext::ESolidPen);
		iGc->SetPenColor(iPenColor);
		iGc->DrawLine(TPoint(aX1,aY1)+iOffset,TPoint(aX2,aY2)+iOffset);
	}
	void setPen(QColor& aColor)
	{
		iPenColor = aColor.Color();
	}
	void translate(TInt aX,TInt aY)
	{
		iOffset = iOffset+TPoint(aX,aY);
	}

	void fillRect(TInt aX,TInt aY,TInt aW,TInt aH,const QColor& aBrush)
	{
		iGc->SetBrushStyle(CGraphicsContext::ESolidBrush);
		iGc->SetBrushColor(aBrush.Color());
		iGc->SetPenStyle(CGraphicsContext::ESolidPen);
		iGc->SetPenColor(aBrush.Color());
		iGc->DrawRect(TRect(TPoint(aX,aY)+iOffset,TSize(aW,aH)));
	}

	void drawPixmap(TInt aX,TInt aY,CWsBitmap* aBitmap,CWsBitmap* aMaskMap = NULL)
	{
		iGc->SetBrushStyle(CGraphicsContext::ENullBrush);
		if(aMaskMap != NULL)
		{
			TRect sourceRect(TPoint(0,0),aBitmap->SizeInPixels());
			iGc->BitBltMasked(TPoint(aX,aY)+iOffset,aBitmap,sourceRect,aMaskMap,ETrue);
		}
		else
			iGc->BitBlt(TPoint(aX,aY)+iOffset,aBitmap);
	}
	TRgb iPenColor;
	CWindowGc* iGc;
	TPoint iOffset;
};

#endif