#include "Level.h"
#include <eikappui.h>
#include <eikapp.h>
Level::Level(Board *board)
	: board(board), title(_L("Unnamed")), numLevels(0)
{
}

Level::Level(TDesC &name, Board *board)
	: board(board), title(name), numLevels(0)
{
}

Level::~Level()
{
	f.Close();
	delete []iRecords;
}

void
Level::setBoard(Board *board)
{
	this->board = board;
}

Board *
Level::getBoard() const
{
	return board;
}

const TDes&
Level::getTitle() const
{
	return title;
}

size_t
Level::getNumLevels() const
{
	return numLevels;
}

bool
Level::loadLevelFile(const TDesC &filename)
{
	TInt loop=0;
	if (filename == _L(""))
		return false;

	setNumLevels(0);
	TFileName appPath;
	TParsePtr parser(CEikonEnv::Static()->EikAppUi()->Application()->AppFullName());
	appPath=parser.DriveAndPath();
	appPath.Append(filename);

	f.Close(); // make sure f is closed first
	if (f.Open(CEikonEnv::Static()->FsSession(),appPath,/*IO_ReadOnly*/EFileShareAny)!=KErrNone)
		return false;

	if (!isValidFormat())
	{
		f.Close();

		return false;
	}

	if (!readHeader())
	{
		f.Close();

		return false;
	}
	f.Size(iFileSize);
	parser = TParsePtr(appPath);
	iFileName=parser.DriveAndPath();
	iFileName.Append(parser.Name());
	iFileName.Append(_L(".rec"));

	delete []iRecords;
	iRecords = NULL;
	iRecords = new TUint16[numLevels];
	for(loop=0;loop<numLevels;loop++)
		iRecords[loop]=-1; // reset score to not done
		RFile recs;
	if(recs.Open(CEikonEnv::Static()->FsSession(),iFileName,0)==KErrNone)
	{
		TPtr8 ptr((unsigned char*)&iRecords[0],sizeof(TUint16)*numLevels);
		recs.Read(ptr);
		recs.Close();
	}
	return true;
}

TInt Level::Record(size_t level)
{
	return iRecords[level];
}
void Level::SetRecord(size_t level, TUint16 moves)
{
	iRecords[level]=moves;
	RFile recs;
	CEikonEnv::Static()->FsSession().Delete(iFileName);
	if(recs.Create(CEikonEnv::Static()->FsSession(),iFileName,EFileWrite)==KErrNone)
	{
		TPtrC8 ptr((unsigned char*)&iRecords[0],sizeof(TUint16)*numLevels);
		recs.Write(ptr);
		recs.Close();
	}
}


void
Level::setTitle(const TDesC &title)
{
	this->title = title;
}

void
Level::setNumLevels(size_t num)
{
	this->numLevels = num;
}
