#include "base.h"
#include "LevelsDialog.h"
#include <eikclb.h>
#include <eikclbd.h>
#include <eiktxlbm.h>

#ifdef LOCAL_COMPILE
# include <sys/types.h>
# include <dirent.h>
#include <string.h>
#endif
#include <eikapp.h>
#include <eikappui.h>
LevelsDialog::LevelsDialog(TFileName& aFileName):curFilename(aFileName)
{
}

const TDesC&
LevelsDialog::getSelectedFilename() const
{
	return curFilename;
}

void
LevelsDialog::loadLevels()
{
	// XXX Need this hack because my qpe crashes on QDir calls. 
#ifdef LOCAL_COMPILE
	TFileName appPath;
	TFileName levelName;
	TParsePtr parser(CEikonEnv::Static()->EikAppUi()->Application()->AppFullName());
	appPath=parser.DriveAndPath();
	appPath.Append(_L("levels"));
	TBuf8<256>fname;
	fname.Copy(appPath);
	DIR *dir = opendir((const char*)fname.PtrZ()/*DATA_PREFIX "levels"*/);
	struct dirent *ent;

	if (dir == NULL)
	{
		iEikonEnv->InfoWinL(_L("Tickypip"),_L("Level directory was not found!"));
		return;
	}

#else
	QDir dir(DATA_PREFIX "levels");

	if (!dir.exists())
	{
		qWarning(tr("Cannot find levels directory!"));
		return;
	}

	dir.setFilter(QDir::Files);
#endif
	// XXX *cringe* 
#ifdef LOCAL_COMPILE
	while ((ent = readdir(dir)) != NULL)
	{
		if (!strcmp(ent->d_name, "..") || !strcmp(ent->d_name, "."))
			continue;

		char* filename = ent->d_name;
#else
	for (size_t i = 0; i < dir.count(); i++)
	{
		QString filename = dir[i];
#endif

		Level *level = new TPLevel();
		TPtrC8 ptr((unsigned char*)filename,strlen(filename));
		appPath.Copy(ptr);
		appPath.Insert(0,_L("Levels\\"));
		levelName.Copy(ptr);
		if (level->loadLevelFile(/*DATA_PREFIX "levels/" + filename*/appPath) == false)
		{
			delete level;
			levelName.Copy(ptr);
			level = new NetWalkLevel(levelName);

			if (level->loadLevelFile(/*DATA_PREFIX "levels/" +
									 filename*/appPath) == false)
			{
				delete level;
				level = NULL;
			}
		}

		if (level != NULL)
		{
			TBuf<256+64+4> item;
			item.Format(_L("%S\t%d\t%S"),&(level->getTitle()),level->getNumLevels(),&levelName);
			filenames->AppendL(item);
		}

		delete level;
	}
	closedir(dir);
}

void LevelsDialog::PostLayoutDynInitL()
{
	iListBox=static_cast<CEikColumnListBox*>(ControlOrNull(0x1000));
	CColumnListBoxItemDrawer* model = iListBox->ItemDrawer();
	CColumnListBoxData* colData = model->ColumnData();
	if(colData != NULL)
	{
	colData->SetColumnWidthPixelL(0,99);
	colData->SetColumnAlignmentL(1,CGraphicsContext::ERight);
	colData->SetColumnWidthPixelL(1,(iEikonEnv->EikAppUi()->ClientRect().Size().iWidth-99)-30);
	colData->SetColumnWidthPixelL(2,0);
	}
	filenames = new (ELeave) CDesCArrayFlat(5);
	loadLevels();
	iListBox->Model()->SetItemTextArray(filenames);
	iListBox->HandleItemAdditionL();
}

TBool LevelsDialog::OkToExitL(TInt /*aButtonId*/)
{
	TInt index= iListBox->CurrentItemIndex();
	if(index>=0 && index<filenames->Count())
	{
		TInt split = filenames->MdcaPoint(index).LocateReverse('\t');
		if(split != KErrNotFound)
		{
			TInt len = filenames->MdcaPoint(index).Length();
			curFilename = filenames->MdcaPoint(index).Right((len-split)-1);
		}
	}
	return ETrue; 
}