#include "Tickypip.h"
#include <eikappui.h>
#include <eikenv.h>
#include <tickypip.rsg>
Tickypip::Tickypip()
{
	CreateWindowL();
	SetRect(iEikonEnv->EikAppUi()->ClientRect());

	levelPacks = new (ELeave) CEikCommandButton;
	levelPacks->SetContainerWindowL(*this);
	levelPacks->SetObserver(this);
	levelPacks->SetTextL(_L("Level Packs"));
	levelPacks->SetSize(levelPacks->MinimumSize());
	/* Add the level drop-down. */
	levelsCombo = new (ELeave)CEikChoiceList;
	levelsCombo->ConstructL(this,0,5);
	CDesCArrayFlat* choiceArray = new (ELeave)CDesCArrayFlat(5);
	levelsCombo->SetArrayL(choiceArray);
	levelsCombo->SetContainerWindowL(*this);
	levelsCombo->SetSize(levelsCombo->MinimumSize());
	levelsCombo->SetPosition(TPoint(Size().iWidth-levelsCombo->Size().iWidth,0));
	levelsCombo->SetObserver(this);

	/* Add the "Next Level" button */
/*	nextButton = new (ELeave) CEikCommandButton;
	nextButton->SetTextL(_L("Next level"));
	nextButton->SetObserver(this);
	nextButton->SetContainerWindowL(*this);
	nextButton->SetSize(nextButton->MinimumSize());
	
	nextButton->SetPosition(TPoint(Size().iWidth/2-nextButton->Size().iWidth/2,(Rect().iBr.iY-nextButton->Size().iHeight)-5));
*/	

//	nextButton->MakeVisible(EFalse);

	/* Add the board. */
	board = new QTPBoard(this);
	board->SetContainerWindowL(*this);
	board->SetPosition(TPoint(board->Position().iX,levelsCombo->Size().iHeight+5));
	board->SetObserver(this);
	movesLabel= new (ELeave) CEikLabel;
	movesLabel->SetContainerWindowL(*this);
	movesLabel->SetFont(iEikonEnv->LegendFont());

	reset(); // start off with the default level set.. show on level selector

	/* Add the moves counter label. */
	iMoves = 0;
	if(board->getBoard()->getLevel()!=NULL)
		iRecord =board->getBoard()->getLevel()->Record(0);

	/* Pop up the levels dialog */
//	if (!selectLevelPack())
//		exit(0);

	ActivateL();
}

Tickypip::~Tickypip()
{
	delete levelsCombo;
	delete movesLabel;
	delete board;
	delete levelPacks;
//	delete nextButton; 
}

void
Tickypip::reset()
{
	Level *level;

	iMoves = 0;
	if(board->getBoard()->getLevel()!= NULL)
		iRecord =board->getBoard()->getLevel()->Record(0);
	updateMoveLabel();
	levelsCombo->SetCurrentItem(0);
	levelsCombo->DesCArray()->Reset();//clear();

	level = board->getBoard()->getLevel();

	if (level != NULL)
	{
		for (size_t i = 0; i < level->getNumLevels(); i++)
		{
			TBuf<64> item;
			item.Format(_L("Level %d"),i+1);
			levelsCombo->DesCArray()->AppendL(item);//(tr("Level %1").arg(QString::number(i + 1)));
		}
	}
}

void
Tickypip::levelCompleted()
{
	//nextButton->MakeVisible(ETrue);

#if 1
	TBuf<256>message;
	message.Format(_L("%d moves!"),iMoves);
	message.Insert(0,_L("Congratulations!\n\nLevel completed in "));
	int curLevel = levelsCombo->CurrentItem();

	//message = message + movesLabel->text() + " moves!";
	
	if(iMoves<board->getBoard()->getLevel()->Record(curLevel))
	{
		board->getBoard()->getLevel()->SetRecord(curLevel,iMoves);
		message.Append(_L("\nThis is a new record! :-) "));
	}

	if (curLevel + 1 == (int)board->getBoard()->getLevel()->getNumLevels())
	{
		message.Append(_L("\n\nLevel pack completed!\nPlease select another levelpack!"));
		//QMessageBox::information(this, "Tickypip", message, "New Level Pack");
		iEikonEnv->InfoWinL(_L("Tickypip"),message);
		selectLevelPack();
	}
	else
	{
		//QMessageBox::information(this, "Tickypip", message, "Next Level");
		message.Append(_L("\n\nGoto the next level!"));
		iEikonEnv->InfoWinL(_L("Tickypip"),message);
		levelChanged(levelsCombo->CurrentItem() + 1);
	}
#endif
}

void
Tickypip::incMovesCount()
{
	iMoves++;
	updateMoveLabel();
	movesLabel->DrawDeferred();
}

void
Tickypip::levelChanged(int level)
{
//	nextButton->MakeVisible(EFalse);
	levelsCombo->SetCurrentItem(level);

	iMoves = 0;
	board->iDisableUpdate=ETrue;
	board->getBoard()->getLevel()->setupLevel(level);
	board->resetSizes();
	board->iDisableUpdate=EFalse;
	iRecord =board->getBoard()->getLevel()->Record(level);

	updateMoveLabel();

	DrawNow();
}

/*void
Tickypip::nextLevel()
{
	levelChanged(levelsCombo->CurrentItem() + 1);
}*/

bool
Tickypip::selectLevelPack()
{
	TFileName filename;
	LevelsDialog* levelsDialog = new (ELeave) LevelsDialog(filename);
	int r =levelsDialog->ExecuteLD(R_SELECT_PACK);// levelsDialog.exec();

//	nextButton->MakeVisible(EFalse);

	if (r)
	{
		if (filename == _L(""))
			return false;
		TFileName fullFileName = _L("levels\\");
		fullFileName.Append(filename);
		board->loadLevel(fullFileName/*DATA_PREFIX "levels/" + filename*/, 0);

		return true;
	}
	return false;
}


	/**
	 *
	 * Returns a <code>TVwsViewId</code> uniquely identifying the view.
	 *
	 * @returns   "TVwsViewId"
	 *            Represents a view in the server.
	 */
TVwsViewId Tickypip::ViewId() const
{
	TVwsViewId viewId(TUid::Uid(0x101F9B51),TUid::Uid(0x12344321));
	return viewId;
}

void Tickypip::ViewActivatedL(const TVwsViewId& /*aPrevViewId*/,TUid /*aCustomMessageId*/,const TDesC8& /*aCustomMessage*/)
{
	MakeVisible(ETrue);
}

	/**
	 *
	 * Takes any action that is required following deactivation of the view.
	 *
	 * This reduces the work required of the window server.
	 *
	 */
void Tickypip::ViewDeactivated()
{
	MakeVisible(EFalse);
}



void Tickypip::HandleControlEventL(CCoeControl* aControl,TCoeEvent aEventType)
{
	if(aEventType == EEventRequestFocus)
	{
		if(iFocused!= NULL)
			iFocused->SetFocus(EFalse);
		iFocused = aControl;
		iFocused->SetFocus(ETrue);
	}
	if(aEventType == EEventStateChanged)
	{
/*		if(aControl == nextButton)
		{
			nextLevel();
		}
		else */if (aControl == levelPacks)
		{
			selectLevelPack();
		}
		else if(aControl == levelsCombo)
		{
			levelChanged(levelsCombo->CurrentItem());
		}
	}
}


TInt Tickypip::CountComponentControls()const 
{
	return 4;
}

void Tickypip::updateMoveLabel()
{
  TBuf<20> moves;
  if(iRecord>0 && iRecord<65535)
	moves.Format(_L("Moves: %d/%d"),iMoves,iRecord); 
		else
	moves.Format(_L("Moves: %d/-"),iMoves); 
	movesLabel->SetTextL(moves);
	movesLabel->SetSize(movesLabel->MinimumSize());
	movesLabel->SetPosition(TPoint(Size().iWidth/2-movesLabel->Size().iWidth/2,Rect().iBr.iY-movesLabel->Size().iHeight));
}

CCoeControl* Tickypip::ComponentControl(TInt aIndex)const
{
	switch(aIndex)
	{
	case 0:
		return board;
	case 1:
		return movesLabel;
//	case 2:
//		return nextButton;
	case 2:
		return levelPacks;
	default:
	case 3:
		return levelsCombo;
	}
}

void Tickypip::Draw(const TRect& aRect) const
{
	CWindowGc& gc = SystemGc();
	gc.SetBrushStyle(CGraphicsContext::ESolidBrush);
	gc.SetPenStyle(CGraphicsContext::ENullPen);
	gc.SetBrushColor(iEikonEnv->Color(EColorWindowBackground));
	gc.Clear(aRect);
}
